(* Simple minded ia32 compiler *)

(* Usage: ./zyva.byte pgm.ext
   Output: pgm.s [assembler] and pgm.out [executable] *)

open Pcf

let file = Sys.argv.(1)

let protect close chan f =
  let t =
    try f chan
    with e -> close chan ; raise e in
  close chan ;
  t
  
let t = protect close_in (open_in file) Reader.from_chan


let () =
  let ty = Poly.infer t in
  Printf.fprintf stdout "type: %a\n" Printer.ty ty ;
  let base = try Filename.chop_extension file with _ -> file in
  let ass =base ^ ".s" in
  protect close_out (open_out ass) (fun chan -> Ia32.compile chan t) ;
  ignore
    (Sys.command
       (Printf.sprintf "cc -O -o %s.out %s zyva.c" base ass))

